﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace DemoAPIC
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        public class PortAccess
        {
            [DllImport("CashDrawer.dll", EntryPoint = "fnPxGetCashDrawerStatus")]
            public static extern bool fnPxGetCashDrawerStatus(short num_drawer);
            [DllImport("CashDrawer.dll", EntryPoint = "fnPxCashDrawerOpen")]
            public static extern bool fnPxCashDrawerOpen(short num_drawer);
        }
        private void Cashdrawer1_Click(object sender, EventArgs e)
        {
            PortAccess.fnPxCashDrawerOpen(0x01);
            timer1.Start();
        }

        private void Cashdrawer2_Click(object sender, EventArgs e)
        {
            PortAccess.fnPxCashDrawerOpen(0x02);
            timer1.Start();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            CheckStatus1();
            CheckStatus2();  
        }
       
        public void CheckStatus1()
        {
            bool bstatus;
            bstatus = PortAccess.fnPxGetCashDrawerStatus(0x01);

            if (bstatus == true)
                State1.Text = "OPEN";
            else
                State1.Text = "CLOSE";
        }
        public void CheckStatus2()
        {
            bool bstatus;
            bstatus = PortAccess.fnPxGetCashDrawerStatus(0x02);

            if (bstatus == true)
                State2.Text = "OPEN";
            else
                State2.Text = "CLOSE";
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            timer1.Interval = 500;
        }
    }
}