﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace DempAPI_Digital
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            bool returnvalue;
            returnvalue = PortAccess.Digital_Initial();
        }

        public class PortAccess
        {
            [DllImport("Digital.dll", EntryPoint = "Digital_Initial")]
            public static extern bool Digital_Initial();

            [DllImport("Digital.dll", EntryPoint = "Digital_Set")]
            public static extern bool Digital_Set(short hex_value);

            [DllImport("Digital.dll", EntryPoint = "Digital_Get")]
            public static extern short Digital_Get(); 
        }


        private void btnWrite_Click(object sender, EventArgs e)
        {
            bool bstatus;
            short temp;
 
            State2.Text = "";
            temp = Convert.ToInt16(Convert.ToByte(txt1.Text, 16)); //16進位轉換10進位

            bstatus = PortAccess.Digital_Set(temp);
            if (bstatus == true)
            {
                State1.Text = "Write Finished";
            }
            else
            {   
                State1.Text = "Write Fail";
            }
        }

        private void btnRead_Click(object sender, EventArgs e)
        {
            State1.Text = "";
            lblRead.Text = "0x" + PortAccess.Digital_Get().ToString("x");
            State2.Text = "Read Finished";
        }
    }
}
