// WatchDogAPDlg.cpp : implementation file
//

#include "stdafx.h"
#include "WatchDogAP.h"
#include "WatchDogAPDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif
int _httoi(const TCHAR *value);
//==============Protech Release API==================== 
typedef bool  (__stdcall *pfnSetwatchdog)(int value);//Set Watch Dog Count Value
typedef bool  (__stdcall *pfnSetMinSec)(int kind);   //Set Watch Dog Count Mode
typedef bool  (__stdcall *pfnRecountWatchdog)();       //Recount WatchDog
typedef bool  (__stdcall *pfnStopwatchdog)();          //Stop WatchDog
//=====================================================
HINSTANCE hFControl;
int Data=0;//User Input
bool AP_Flag=false;
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CWatchDogAPDlg dialog




CWatchDogAPDlg::CWatchDogAPDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWatchDogAPDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CWatchDogAPDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CWatchDogAPDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, &CWatchDogAPDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON3, &CWatchDogAPDlg::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, &CWatchDogAPDlg::OnBnClickedButton4)
	ON_BN_CLICKED(IDC_BUTTON5, &CWatchDogAPDlg::OnBnClickedButton5)
	ON_BN_CLICKED(IDC_BUTTON2, &CWatchDogAPDlg::OnBnClickedButton2)
END_MESSAGE_MAP()


// CWatchDogAPDlg message handlers

BOOL CWatchDogAPDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	if ( (hFControl = LoadLibrary(_T("WatchDog.dll"))) == NULL)
		AfxMessageBox(_T("Load WatchDog.dll Failed"));
	//==================================================================
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CWatchDogAPDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CWatchDogAPDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CWatchDogAPDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CWatchDogAPDlg::OnBnClickedButton1()
{
	// TODO: Add your control notification handler code here

	bool result_code = false;


	pfnSetMinSec SetMinSec;
	SetMinSec = (pfnSetMinSec) GetProcAddress(hFControl, "SetMinSec");
	if(SetMinSec)
	{
		result_code = SetMinSec(1);//sec

		if (result_code)
		{
#ifdef _DEBUG
			WCHAR	wzDebug[64];
			swprintf(wzDebug, 64, L"WatchDog SetMinSec ok! \n");
			OutputDebugString(wzDebug);
#endif
		}
	}
}

void CWatchDogAPDlg::OnBnClickedButton2()
{
// TODO: Add your control notification handler code here

	bool result_code = false;


	pfnSetMinSec SetMinSec;
	SetMinSec = (pfnSetMinSec) GetProcAddress(hFControl, "SetMinSec");
	if(SetMinSec)
	{
		result_code = SetMinSec(2);//min

		if (result_code)
		{
#ifdef _DEBUG
			WCHAR	wzDebug[64];
			swprintf(wzDebug, 64, L"WatchDog SetMinSec ok! \n");
			OutputDebugString(wzDebug);
#endif
		}
	}
}

int _httoi(const TCHAR *value)
{
	struct CHexMap
	{
		TCHAR chr;
		int value;
	};
	const int HexMapL = 16;
	CHexMap HexMap[HexMapL] =
	{
		{'0', 0}, {'1', 1},
		{'2', 2}, {'3', 3},
		{'4', 4}, {'5', 5},
		{'6', 6}, {'7', 7},
		{'8', 8}, {'9', 9},
		{'A', 10}, {'B', 11},
		{'C', 12}, {'D', 13},
		{'E', 14}, {'F', 15}
	};
	TCHAR *mstr = _tcsupr(_tcsdup(value));
	TCHAR *s = mstr;
	int result = 0;
	if (*s == '0' && *(s + 1) == 'X') s += 2;
	bool firsttime = true;
	while (*s != '\0')
	{
		bool found = false;
		for (int i = 0; i < HexMapL; i++)
		{
			if (*s == HexMap[i].chr)
			{
				if (!firsttime) result <<= 4;
				result |= HexMap[i].value;
				found = true;
				break;
			}
		}
		if (!found) break;
		s++;
		firsttime = false;
	}
	free(mstr);
	return result;
}

void CWatchDogAPDlg::OnBnClickedButton3()
{
	// TODO: Add your control notification handler code here
	bool result_code = false;
	//int Data; //Write Data [0~255]
	CString	wzData;



	CEdit* wEdit1=(CEdit*)GetDlgItem(IDC_EDIT1);
	wEdit1->GetWindowTextW (wzData);
	Data = _ttoi(wzData);
	//Data=_httoi(wzData);
	if (Data == NULL)
	{
		MessageBox( L"Please fill in value!", L"WatchDog Application", MB_OK); 
		return;
	}
	else if (Data > 255)
	{
		MessageBox( L"Over  Range![0~255]", L"WatchDog Application", MB_OK); 
		return;
	}



	pfnSetwatchdog Setwatchdog;
	Setwatchdog = (pfnSetwatchdog) GetProcAddress(hFControl, "Setwatchdog");
	if(Setwatchdog)
	{
		result_code = Setwatchdog(Data);
		AP_Flag = true;
		
		if (result_code)
		{
#ifdef _DEBUG
			WCHAR	wzDebug[64];
			swprintf(wzDebug, 64, L"WatchDog Setting ok! \n");
			OutputDebugString(wzDebug);
#endif
		}
	}
}

void CWatchDogAPDlg::OnBnClickedButton4()
{
	// TODO: Add your control notification handler code here
	bool result_code = false;
	if (AP_Flag == false)
	{
		MessageBox( L"Please Press Start Button!", L"WatchDog Application", MB_OK); 
		return;
	}

	if (Data == NULL)
	{
		MessageBox( L"Please fill in value!", L"WatchDog Application", MB_OK); 
		return;
	}
	else if (Data > 255)
	{
		MessageBox( L"Over  Range![0~255]", L"WatchDog Application", MB_OK); 
		return;
	}


	pfnRecountWatchdog RecountWatchdog;
	RecountWatchdog = (pfnRecountWatchdog) GetProcAddress(hFControl, "RecountWatchdog");
	if(RecountWatchdog)
	{
		result_code = RecountWatchdog();
		
		if (result_code)
		{
#ifdef _DEBUG
			WCHAR	wzDebug[64];
			swprintf(wzDebug, 64, L"WatchDog Recount ok! \n");
			OutputDebugString(wzDebug);
#endif
		}
	}

}

void CWatchDogAPDlg::OnBnClickedButton5()
{
	// TODO: Add your control notification handler code here

	bool result_code = false;
	if (AP_Flag == false)
	{
		MessageBox( L"Please Press Start Button!", L"WatchDog Application", MB_OK); 
		return;
	}

	if (Data == NULL)
	{
		MessageBox( L"Please fill in value!", L"WatchDog Application", MB_OK); 
		return;
	}
	else if (Data > 255)
	{
		MessageBox( L"Over  Range![0~255]", L"WatchDog Application", MB_OK); 
		return;
	}


	pfnStopwatchdog Stopwatchdog;
	Stopwatchdog = (pfnStopwatchdog) GetProcAddress(hFControl, "Stopwatchdog");
	if(Stopwatchdog)
	{
		result_code = Stopwatchdog();

		if (result_code)
		{
#ifdef _DEBUG
			WCHAR	wzDebug[64];
			swprintf(wzDebug, 64, L"WatchDog Stop ok! \n");
			OutputDebugString(wzDebug);
#endif
		}
	}
}

