﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace DemoAPI
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            bool returnvalue;
            //Initialize GPIO Function
            returnvalue = PortAccess.GPIO_Initial();
        }

        /// <summary>
        /// API Define
        /// </summary>
        public class PortAccess
        {
            [DllImport("GPIO.dll", EntryPoint = "GPIO_Initial")]
            public static extern bool GPIO_Initial();

            [DllImport("GPIO.dll", EntryPoint = "GPIO_Set")]
            public static extern bool GPIO_Set(long dout_value);

            [DllImport("GPIO.dll", EntryPoint = "GPIO_Get")]
            public static extern long GPIO_Get();

            [DllImport("GPIO.dll", EntryPoint = "GPIO_SetPort")]
            public static extern bool GPIO_Setport(long dout_value);
        }

        private void btnWrite_Click(object sender, EventArgs e)
        {
            bool bstatus;
            Int64 temp;
            State2.Text = "";
            temp = Convert.ToInt32(Convert.ToInt32(txt1.Text, 16)); 
            //GPIO Set Function
            bstatus = PortAccess.GPIO_Set(temp);
            if (bstatus == true)
            {
                State1.Text = "Write Finished";
            }
            else
            {
                State1.Text = "Write Fail";
            }
        }

        long  GPIO_Get = 0;
        private void btnRead_Click(object sender, EventArgs e)
        {
            State1.Text = "";
            GPIO_Get = 0;
            GPIO_Get = PortAccess.GPIO_Get();
            GPIO_Get = GPIO_Get & 0xffff;
            lblRead.Text = "0x" + GPIO_Get.ToString("x");
            State2.Text = "Read Finished";
        }


        private void btnSetport_Click(object sender, EventArgs e)
        {
            bool bstatus2;
            Int64 temp2;
            temp2 = Convert.ToInt32(Convert.ToInt32(txt2.Text , 16)); 
            //GPIO Set Port Direction
            bstatus2 = PortAccess.GPIO_Setport(temp2);
            if (bstatus2 == true)
            {
                State3.Text = "Write Finished";
            }
            else
            {
                State3.Text = "Write Fail";
            }
        }
        private void Form1_Load(object sender, EventArgs e)
        {

        }
    }
}
